<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_GenericDataCatalogueRequest StructType
 * @subpackage Structs
 */
class JP_GenericDataCatalogueRequest extends AbstractStructBase
{
    /**
     * The Type
     * @var string
     */
    public $Type;
    /**
     * Constructor method for JP_GenericDataCatalogueRequest
     * @uses JP_GenericDataCatalogueRequest::setType()
     * @param string $type
     */
    public function __construct($type = null)
    {
        $this
            ->setType($type);
    }
    /**
     * Get Type value
     * @return string|null
     */
    public function getType()
    {
        return $this->Type;
    }
    /**
     * Set Type value
     * @uses \EnumType\JP_GenericCatalogueType::valueIsValid()
     * @uses \EnumType\JP_GenericCatalogueType::getValidValues()
     * @throws \InvalidArgumentException
     * @param string $type
     * @return \StructType\JP_GenericDataCatalogueRequest
     */
    public function setType($type = null)
    {
        // validation for constraint: enumeration
        if (!\EnumType\JP_GenericCatalogueType::valueIsValid($type)) {
            throw new \InvalidArgumentException(sprintf('Invalid value(s) %s, please use one of: %s from enumeration class \EnumType\JP_GenericCatalogueType', is_array($type) ? implode(', ', $type) : var_export($type, true), implode(', ', \EnumType\JP_GenericCatalogueType::getValidValues())), __LINE__);
        }
        $this->Type = $type;
        return $this;
    }
}
